// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GIOMM_FILEATTRIBUTE_H
#define _GIOMM_FILEATTRIBUTE_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* Copyright (C) 2007 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string>
#include <gio/gio.h>
#include <glibmm/object.h>


namespace Gio
{

//TODO: Fix the need for NO_GTYPE.
/** @addtogroup giommEnums Enums and Flags */

/**
 * @ingroup giommEnums
 */
enum FileAttributeType
{
  FILE_ATTRIBUTE_TYPE_INVALID,
  FILE_ATTRIBUTE_TYPE_STRING,
  FILE_ATTRIBUTE_TYPE_BYTE_STRING,
  FILE_ATTRIBUTE_TYPE_BOOLEAN,
  FILE_ATTRIBUTE_TYPE_UINT32,
  FILE_ATTRIBUTE_TYPE_INT32,
  FILE_ATTRIBUTE_TYPE_UINT64,
  FILE_ATTRIBUTE_TYPE_INT64,
  FILE_ATTRIBUTE_TYPE_OBJECT
};


/**
 * @ingroup giommEnums
 * @par Bitwise operators:
 * <tt>%FileAttributeInfoFlags operator|(FileAttributeInfoFlags, FileAttributeInfoFlags)</tt><br>
 * <tt>%FileAttributeInfoFlags operator&(FileAttributeInfoFlags, FileAttributeInfoFlags)</tt><br>
 * <tt>%FileAttributeInfoFlags operator^(FileAttributeInfoFlags, FileAttributeInfoFlags)</tt><br>
 * <tt>%FileAttributeInfoFlags operator~(FileAttributeInfoFlags)</tt><br>
 * <tt>%FileAttributeInfoFlags& operator|=(FileAttributeInfoFlags&, FileAttributeInfoFlags)</tt><br>
 * <tt>%FileAttributeInfoFlags& operator&=(FileAttributeInfoFlags&, FileAttributeInfoFlags)</tt><br>
 * <tt>%FileAttributeInfoFlags& operator^=(FileAttributeInfoFlags&, FileAttributeInfoFlags)</tt><br>
 */
enum FileAttributeInfoFlags
{
  FILE_ATTRIBUTE_INFO_NONE = 0,
  FILE_ATTRIBUTE_INFO_COPY_WITH_FILE = 1 << 0,
  FILE_ATTRIBUTE_INFO_COPY_WHEN_MOVED = 1 << 1
};

/** @ingroup giommEnums */
inline FileAttributeInfoFlags operator|(FileAttributeInfoFlags lhs, FileAttributeInfoFlags rhs)
  { return static_cast<FileAttributeInfoFlags>(static_cast<unsigned>(lhs) | static_cast<unsigned>(rhs)); }

/** @ingroup giommEnums */
inline FileAttributeInfoFlags operator&(FileAttributeInfoFlags lhs, FileAttributeInfoFlags rhs)
  { return static_cast<FileAttributeInfoFlags>(static_cast<unsigned>(lhs) & static_cast<unsigned>(rhs)); }

/** @ingroup giommEnums */
inline FileAttributeInfoFlags operator^(FileAttributeInfoFlags lhs, FileAttributeInfoFlags rhs)
  { return static_cast<FileAttributeInfoFlags>(static_cast<unsigned>(lhs) ^ static_cast<unsigned>(rhs)); }

/** @ingroup giommEnums */
inline FileAttributeInfoFlags operator~(FileAttributeInfoFlags flags)
  { return static_cast<FileAttributeInfoFlags>(~static_cast<unsigned>(flags)); }

/** @ingroup giommEnums */
inline FileAttributeInfoFlags& operator|=(FileAttributeInfoFlags& lhs, FileAttributeInfoFlags rhs)
  { return (lhs = static_cast<FileAttributeInfoFlags>(static_cast<unsigned>(lhs) | static_cast<unsigned>(rhs))); }

/** @ingroup giommEnums */
inline FileAttributeInfoFlags& operator&=(FileAttributeInfoFlags& lhs, FileAttributeInfoFlags rhs)
  { return (lhs = static_cast<FileAttributeInfoFlags>(static_cast<unsigned>(lhs) & static_cast<unsigned>(rhs))); }

/** @ingroup giommEnums */
inline FileAttributeInfoFlags& operator^=(FileAttributeInfoFlags& lhs, FileAttributeInfoFlags rhs)
  { return (lhs = static_cast<FileAttributeInfoFlags>(static_cast<unsigned>(lhs) ^ static_cast<unsigned>(rhs))); }


/**
 * @ingroup giommEnums
 */
enum FileAttributeStatus
{
  FILE_ATTRIBUTE_STATUS_UNSET,
  FILE_ATTRIBUTE_STATUS_SET,
  FILE_ATTRIBUTE_STATUS_ERROR_SETTING
};


// GFileAttributeInfo struct hand-wrapped
// TODO: Use _CLASS_GENERIC?

/** Information about a specific attribute - see FileAttributeInfoList.
 *
 * @newin2p16
 */
class FileAttributeInfo
{
public:
  explicit FileAttributeInfo(const GFileAttributeInfo* ginfo);

  FileAttributeInfo(const FileAttributeInfo& other);
  FileAttributeInfo& operator=(const FileAttributeInfo& other);

  ~FileAttributeInfo();

  std::string get_name() const;
  FileAttributeType get_type() const;
  FileAttributeInfoFlags get_flags() const;

protected:
  std::string m_name;
  FileAttributeType m_type;
  FileAttributeInfoFlags m_flags;
};


/** Key-Value paired file attributes.
 * File attributes in GIO consist of a list of key-value pairs.
 *
 * Keys are strings that contain a key namespace and a key name, separated by a colon, e.g. "namespace:keyname". 
 * Namespaces are included to sort key-value pairs by namespaces for relevance. Keys can be retreived using wildcards, 
 * e.g. "standard::*" will return all of the keys in the "standard" namespace.
 *
 * Values are stored within the list in Gio::FileAttributeValue structures. Values can store different types, listed in the enum 
 * Gio::FileAttributeType. Upon creation of a Gio::FileAttributeValue, the type will be set to Gio::FILE_ATTRIBUTE_TYPE_INVALID.
 *
 * The list of possible attributes for a filesystem (pointed to by a Gio::File) is availible as a Gio::FileAttributeInfoList. 
 * This list is queryable by key names as indicated earlier.
 *
 * Classes that implement Gio::FileIface will create a Gio::FileAttributeInfoList and install default keys and values for their given file 
 * system, architecture, and other possible implementation details (e.g., on a UNIX system, a file attribute key will be registered for 
 * the user id for a given file).
 *
 * See http://library.gnome.org/devel/gio/unstable/gio-GFileAttribute.html for the list of default namespaces and the list of default keys.
 *
 * @newin2p16
 */
class FileAttributeInfoList
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef FileAttributeInfoList CppObjectType;
  typedef GFileAttributeInfoList BaseObjectType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  static Glib::RefPtr<FileAttributeInfoList> create();

  // For use with Glib::RefPtr<> only.
  void reference()   const;
  void unreference() const;

  ///Provides access to the underlying C instance.
  GFileAttributeInfoList*       gobj();

  ///Provides access to the underlying C instance.
  const GFileAttributeInfoList* gobj() const;

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GFileAttributeInfoList* gobj_copy() const;

protected:
  // Do not derive this.  Gio::FileAttributeInfoList can neither be constructed nor deleted.
  FileAttributeInfoList();
  void operator delete(void*, size_t);

private:
  // noncopyable
  FileAttributeInfoList(const FileAttributeInfoList&);
  FileAttributeInfoList& operator=(const FileAttributeInfoList&);


public:

  //TODO: Add FileAttributeInfo::empty() or similar so we can represent a NULL GFileAttributeInfo*.
  /** Gets the file attribute with the name name from list. 
   * @param name The name of the attribute to lookup.
   * @result A FileAttributeInfo for the name.
   */
  FileAttributeInfo lookup(const std::string& name) const;

  /*TODO: conversion missing
  _WRAP_METHOD(void add(const std::string& name, FileAttributeType type, FileAttributeInfoFlags flags),
               g_file_attribute_info_list_add)
  */


};

} // namespace Gio


namespace Glib
{

  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gio::FileAttributeInfoList
   */
  Glib::RefPtr<Gio::FileAttributeInfoList> wrap(GFileAttributeInfoList* object, bool take_copy = false);

} // namespace Glib


#endif /* _GIOMM_FILEATTRIBUTE_H */

